﻿using System;
using System.Drawing;
using System.Linq;
using System.Collections.Generic;
using System.Text;

namespace INT_PT002.DataStore
{
    public class Define
    {
        public static readonly Color ColorSelected = Color.MediumSeaGreen;
        public static readonly Color ColorNoneSelected = Color.White;

        public static readonly Color ColorProgressOff = Color.Azure;
        public static readonly Color ColorProgressOn = Color.Lime;

        public static readonly Color ColorTextResultPass = Color.Green;
        public static readonly Color ColorTextResultNG = Color.Red;
        public static readonly Color ColorTextResultNone = Color.LightGray;

        public delegate void EventHandlerAlarmStateChange(Define.E_TrackingAlarm alarm, string status);

        public enum E_EquipmentStatus
        {
            Stop = 0,
            Start = 1,
        }

        public enum E_FormStore
        {
            FormNone = 0,
            FormMainDisplay,
            FormMenu,
        }

        public enum E_EquipmentMode
        {
            Normal,
            Menu,
            IOTest,
            EquipmentTest,
        }

        public enum E_TopMenuStore
        {
            Recipe,
            User,
            Manual,
            Log,
            System,
        }
        public enum E_MenuRecipeStore
        {
            _0_None,
            _1_Setting,
        }
        public enum E_MenuUserStore
        {
            _0_None,
            _1_UserEditor,
            _2_GroupEditor,
        }
        public enum E_MenuManualStore
        {
            _0_None,
            _1_IoTest,
        }
        public enum E_MenuLogStore
        {
            _0_None,
            _1_Inspection,
            _2_History,
            _3_Alarm,
        }
        public enum E_MenuSystemStore
        {
            _0_None,
            _1_Information,
            _2_Equipment,
            _3_Ethernet,
            _4_Equipment1,
            _5_Setting,
        }

        public enum E_DisplayModeStore
        { 
            MainDisplay,
            Recipe,
            UserEditor,
            UserMyPage,
            UserGroupEditor,
            IOTest,
            LogInspection,
            LogHistory,
            LogAlarm,
            Information,
            Ethernet,
            Equipment,
            Equipment1,
        }

        public enum E_CommMode
        {
            f0_None = 0,
            f1_Modbus,
        }

        public enum E_ProcessStatus
        {
            _0_None = 0,
            _1_Ready,
            _2_ProductEntry,
            _3_MoveToLeak,
            _4_MoveToCheck,
            _5_ChamberMerge,
            _6_VacuumStart,
            _7_VacuumHold,
            _8_Judgment,
            _9_VacuumBreak,
            _10_ChamberRelease,
            _11_MoveToReady,
        }

        public enum E_JudgmentStatus
        {
            None,
            Pass,
            Ng,
            Empty,
            Error,
        }

        public enum E_ResponseData
        {
            NAK = 0,
            ACK = 1,
        }

        public enum E_UpdateCheck
        {
            Fail,
            Success,
            NoUsbMomery,
            NoUpdateFolder,
            NoFile,
        }

        public enum E_LanguageID
        {
            Korean,
            English,
        }

        public enum E_MessageBoxIcon
        {
            None,
            Hand,
            Question,
            Exclamation,
            Asterisk,
        }

        public enum E_UserGroup
        {
            None = 0,
            Level1 = 1,
            Level2 = 2,
            Level3 = 3,
            Admin = 4,
            Developer = 5,
            NotLogin = 6,
            LogOut = 7,
        }

        public enum E_TrackingOperation
        {
            None,
            PowerOn,
            BootingComplete,
            EquipmentStart,
            EquipmentStop,
            Login,
            Logout,
            Zero,
            Clear,
            UserEditor,

            TryEthernetStart,
            TryEthernetStop,
            ClientConnect,
            ClientDisconnect,
            ServerON,
            ServerOFF,
        }

        public enum E_TrackingParameter
        {
            RecipeNumber,
            Pressure,

            Disp_STD,
            Disp_EmptyLevel,
            Disp_MaxDiff,
            Disp_MinHight,
            Disp_Enable,

            Diff_LrLimit,
            Diff_Cycle,
            Diff_HoldDelay,

            P_reliefTime,
            P_HlodingTime,
            P_HoldingTime2,
            P_BreakTime,

            Etc_LcdDataPeriod,
            Etc_Chattering,
            Etc_CutWait,
            Etc_Buzzer,
            Etc_SbDiffFilter,
            Etc_EquipmentLane,
            Etc_CheckLane,

            M_Origin,
            M_Chamber1,
            M_Chamber2,
            M_Chamber3,
            M_Chamber4,
            M_Chamber5,
            M_Chamber6,
            M_Chamber7,
            M_Chamber8,
            M_Chamber9,
            M_Chamber10,

            ProductNo,

            TCPOpMode,
            TCPComMode,
            TCPLocalPort,
            TCPLocalIPConfig,
            TCPLocalIPAddress,
            TCPLocalSubnetMask,
            TCPLocalGateway,
            TCPServerIPAddress,
            TCPServerPort,
            Mod_Role,
            Mod_StartAddr,
        }

        public enum E_TrackingAlarm
        {
            None,
            a1_ServoEmergencyStop,
            a2_ServoAlarm,
            a3_ServoTorqueAlarm,
            a4_PressureError,
            a5_PressureSensorError,
            a6_,
            a7_,
            a8_,
            a9_SensorBoard1Error,
            a10_SensorBoard2Error,
            a11_SensorBoard3Error,
            a12_SensorBoard4Error,
            a13_SensorBoard5Error,
            a14_SensorBoard6Error,
            a15_SensorBoard7Error,
            a16_SensorBoard8Error,
            a17_SensorBoard9Error,
            a18_SensorBoard10Error,
            a19_,
            a20_,
            a21_DisplacementSensor1Error,
            a22_DisplacementSensor2Error,
            a23_DisplacementSensor3Error,
            a24_DisplacementSensor4Error,
            a25_DisplacementSensor5Error,
            a26_DisplacementSensor6Error,
            a27_DisplacementSensor7Error,
            a28_DisplacementSensor8Error,
            a29_DisplacementSensor9Error,
            a30_DisplacementSensor10Error,
        }

        public enum E_TrackingType
        {
            Operation,
            Parameter,
            Alarm,
        }

        public enum E_DataType
        {
            None,
            History,
            Inspection,
            Alarm,
        }

        public enum E_ModbusFunction
        {
            _04_ReadInputRegister,
            _16_WriteMultipleRegister,
            _03_ReadHoldingRegister,
        }
    }
}
